//**********************************************************************
// HttpGrabber
// ===========
// Test app for the CRhsSocket class
//
// Syntax: HttpGrabber <server> <path> [<port>]
//**********************************************************************

#ifndef STRICT
#define STRICT
#endif

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "../rhssock.h"


//**********************************************************************
// Global variables
//**********************************************************************

#define SYNTAX "Syntax: HttpGrabber <server> <path> [<port>]\n"


//**********************************************************************
// main
// ====
//**********************************************************************

int main(int argc, char* argv[])
{ int port = 80;
  CRhsSocket skt;
  char s[256];

// Check the arguments

  if (argc > 1)
  { if (strcmpi(argv[1], "-?") == 0 || strcmpi(argv[1], "/?") == 0)
    { printf(SYNTAX);
      return(0);
    }
  }

  if (argc < 3 || argc > 4)
  { printf(SYNTAX);
    return(2);
  }

  if (argc > 3)
  { port = atoi(argv[3]);
    if (port == 0)
    { printf("The port number %s is not a valid integer\n", argv[3]);
      return(2);
    }
  }

// Connect to the server

  skt.Startup();

  if (!skt.Connect(argv[1], port))
  { printf("Cannot connect to server %s\n%s\n", argv[1], skt.GetLastErrorMessage(s, 255));
    return(2);
  }

  printf("Connected to %s\n", argv[1]);

// Send the request

  gethostname(s, 255);

  skt.printf("GET %s HTTP/1.0\r\nUser-Agent: HttpGrabber\r\nHost: %s\r\nAccept: *\057*\r\n\r\n", argv[2], s);

// Read the response

  while (skt.gets(s, 255))
    puts(s);

// Disconnect

  skt.CloseSocket();

  skt.Cleanup();

// All done

  return(0);
}


